#ifndef _STUDENT_CPP
#define _STUDENT_CPP

#include <string>
#include <fstream>
#include "Student.h"

using namespace std;

//-----------------------------------------------------------------
//                             
//-----------------------------------------------------------------
void Student::add1Course( int aIncrWH )
{
   if ( aIncrWH <= 0 )
      throw StudentXptn( "add1Course", StudentXptn::nonPosIncr,
                         aIncrWH );
   ++sNoOfCourses;
   sWH += aIncrWH;
} // Student::addCourse

unsigned int Student::countTabs( string aLine )
{
   unsigned int fv( 0 );
   unsigned int ndx( aLine.find("\t") );
   while ( ndx < aLine.length() )
   {
      ++fv;
      ndx = aLine.find( "\t", ndx+1 );
   }
   return fv;
} // countTabs

void Student::readFromText( istream& tin )
{
   string line;
   getline( tin, line, '\n' );
   if ( !tin.eof() )
   {
      size_t t1Pos( line.find("\t") );
      if ( t1Pos >= line.length() )
         throw StudentXptn( "readFromText",
                            StudentXptn::incomplete );
      size_t t2Pos( line.find("\t", t1Pos+1) );
      if ( t2Pos >= line.length() )
         throw StudentXptn( "readFromText",
                            StudentXptn::incomplete );
      string str1( line.substr(0, t1Pos) );
      int    iStr1;
      iStr1 = atoi( str1.c_str() );
      if ( iStr1 <= 0 )
         throw StudentXptn( "readFromText",
                            StudentXptn::negIdNum, iStr1 );
      sIdNum = iStr1;
      str1 = line.substr( t1Pos+1, t2Pos-t1Pos-1 );
      strncpy( sSurname, str1.c_str(), sNameSz-1 );
                                       sSurname[sNameSz-1] = '\0';
      str1 = line.substr( t2Pos+1 );
      strncpy( sFirstname, str1.c_str(), sNameSz-1 );
                                     sFirstname[sNameSz-1] = '\0';
   } // if ( !tin.eof . . .
} // Student::readFromText

void Student::save( ostream& bout ) const
{
   if ( bout.fail() )
      throw StudentXptn( "save", StudentXptn::fileNotOpen );
   bout.write( reinterpret_cast<const char*>(&sIdNum), sizeof(sIdNum) );
                                                          //  
   bout.write( sSurname, sizeof(sSurname) ); 
   bout.write( sFirstname, sizeof(sFirstname) ); 
   bout.write( reinterpret_cast<const char*>(&sWH), sizeof(sWH) );
                                                        //   
   bout.write( reinterpret_cast<const char*>(&sNoOfCourses),
               sizeof(sNoOfCourses) );       //    
   if ( bout.fail() )
      throw StudentXptn( "save", StudentXptn::cannotWrite );
} // Student::save

void Student::display( ostream& tout )
{
   tout << sIdNum << '\t' << sSurname << '\t' << sFirstname << endl
        << sNoOfCourses << '\t' << sWH << endl;
} // Student::display

#endif // _STUDENT_CPP
